---
layout: default
title: What is Version Control and Why is it Important?
description: "Version control software is used to track revisions, solve integration conflicts in code, and manage different artifacts involved in software projects."
suppress_header: true 
extra_css:
  - devops.css
  - agile-delivery.css
extra_js:
  - libs/on-scroll.js
  - in-page-nav.js
  - all-clickable.js
canonical_path: "/version-control/"
---
:erb
  <script type="application/ld+json">{"@context":"https://schema.org","@type":"FAQPage","mainEntity":[{"@type":"Question","name":"What is version control?","acceptedAnswer":{"@type":"Answer","text":"Version control is software used to track revisions, solve integration conflicts in code, and manage different artifacts involved in software projects (e.g. design, data, images). Version control also enables frictionless communication, change, and reproducibility between team members."}},{"@type":"Question","name":"Why use version control?","acceptedAnswer":{"@type":"Answer","text":"Version control facilitates coordination, sharing, and collaboration across the entire software development team. Version control software enables teams to work in distributed and asynchronous environments, manage changes and versions of code and artifacts, and resolve merge conflicts and related anomalies."}},{"@type":"Question","name":"Benefits of version control","acceptedAnswer":{"@type":"Answer","text":"<ul><li>Quality - Teams can review, comment, and improve each other’s code and assets.</li> <li>Acceleration - Branch code, make changes, and merge commits faster.</li> <li>Visibility - Understand and spark team collaboration to foster greater release build and release patterns.</li></ul>"}},{"@type":"Question","name":"Which is the best version control software?","acceptedAnswer":{"@type":"Answer","text":"There are several source code management options that can help your team streamline development. The three most well-known options are Git, SVN, and Mercurial."}}]}</script>


.blank-header
  = image_tag "/images/home/icons-pattern-left.svg", class: "image-border image-border-left", alt: "Gitlab hero border pattern left svg"
  = image_tag "/images/home/icons-pattern-right.svg", class: "image-border image-border-right", alt: "Gitlab hero border pattern right svg"
  .header-content
    = image_tag "/images/version-control/version-control.svg", class: "hero-image-huge", alt: "GitLab version control graphic"
    %h1 What is version control?
    %p Version control enables rapid collaboration and iteration on new features, helping teams deliver business value and meet customer demand.
    %a.btn.cta-btn.orange.devops-cta{ href: "https://learn.gitlab.com/scm?utm_content=topicpage&utm_campaign=vccusecase" } Learn how to streamline development

.wrapper.wrapper--large-fonts
  #content.devops-content.u-margin-top-md
    .wrapper.container.js-in-page-nav-group{role: "main"}
      .row.u-margin-top-lg.js-in-page-nav-section#what-is-version-control
        .col-md-10.col-md-offset-1
          %h2.u-text-brand What is version control?

          %p Version control helps software teams track changes to the code, while enhancing communication and collaboration between team members. Version control facilitates a continuous, simple way to develop software.


          %blockquote.blockquote-alt.cicd-blockquote
            %b Version control
            enables teams to collaborate and streamline development to resolve conflicts and create a centralized location for code.

          %p Source code acts as a single source of truth and a collection of a product’s knowledge, history, and solutions. Version control serves as a safety net to protect the source code from irreparable harm, giving the development team the freedom to experiment without fear of causing damage or creating code conflicts. If developers code concurrently and create incompatible changes, version control identifies the problem areas so that team members can quickly revert changes to a previous version, compare changes, or identify who committed the problem code through the revision history. With version control systems, a software team can solve an issue before progressing further into a project. Through code reviews, software teams can analyze earlier versions to understand how a solution evolved.  

          %p Depending on a team’s specific needs, a version control system can be local, centralized, or distributed. A local version control system stores files within a local system. Centralized version control stores changes in a single server. A distributed version control system involves cloning a Git repository.
          %h4.bold-links
            = link_to "Learn five ways to enhance team collaboration with version control best practices→", "/resources/ebook-version-control-best-practices"

      .row.u-margin-top-lg.js-in-page-nav-section#why-use-version-control
        .col-md-10.col-md-offset-1
          %h2.u-text-brand Why use version control?

          %p Software is developed to solve a user problem. Increasingly, these solutions have many different forms (e.g. mobile, embedded, SaaS) and run a variety of environments, such as cloud, on-prem, or Edge. As organizations accelerate delivery of their software solutions through DevOps, controlling and managing different versions of application artifacts - from code to configuration and from design to deployment - becomes increasingly difficult. Velocity without robust version control and traceability is like driving a car without a seatbelt.

          %p Version control facilitates coordination, sharing, and collaboration across the entire software development team. Version control software enables teams to work in distributed and asynchronous environments, manage changes and versions of code and artifacts, and resolve merge conflicts and related anomalies.
          %h4.bold-links
            = link_to "Read how Git Partial Clone lets you fetch only the large files you need→", "/blog/2020/03/13/partial-clone-for-massive-repositories"


      .row.u-margin-top-lg.js-in-page-nav-section#benefits-of-version-control
        .cta-featured-grid
          .row.u-margin-bottom-md
            .col-md-10.col-md-offset-1
              %h2.u-text-brand Benefits of version control
              .featured-icons.text-center
                .featured-icon
                  = partial "/images/icons/computer-test2.svg"
                  %p.number Quality
                  %p.description Teams can review, comment, and improve each other’s code and assets.
                .featured-icon
                  = partial "/images/icons/pillar-speed-alt.svg"
                  %p.number Acceleration
                  %p.description Branch code, make changes, and merge commits faster.
                .featured-icon
                  = partial "/images/icons/first-look-influence.svg"
                  %p.number Visibility
                  %p.description Understand and spark team collaboration to foster greater release build and release patterns.


      .row.u-margin-top-sm.js-in-page-nav-section#best-version-control-software
        .col-md-10.col-md-offset-1
          %h2.hidden Which is the best?
          %h2.u-text-brand Which is the best version control software?

          %p There are several source code management options that can help your team streamline development. The three most well-known options are Git, SVN, and Mercurial.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px" }
                = image_tag "/images/icons/logo-git.svg"

            .media-body.media-middle
              %h3.u-margin-top-0 Git

              %p.u-margin-bottom-0 Git is the most popular option and has become synonymous with “source code management.” Git is an open source distributed system that is used for software projects of any size, making it a popular option for startups, enterprise, and everything in between.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px;" }
                = image_tag "/images/icons/logo-svn.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Subversion

              %p.u-margin-bottom-0 SVN is a widely adopted centralized version control system. This system keeps all of a project's files on a single codeline making it impossible to branch, so it’s easy to scale for large projects. It’s simple to learn and features folder security measures, so access to subfolders can be restricted.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object{ style: "width: 80px; height: 80px;" }
                = image_tag "/images/icons/logo-mercurial.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Mercurial

              %p.u-margin-bottom-0 Mercurial is a distributed version control system that offers simple branching and merging capabilities. The system enables rapid scaling and collaborative development, with an intuitive interface. The flexible command line interface enables users to begin using the system immediately.


      .row.u-margin-top-sm#version-control-streamline
        .col-md-10.col-md-offset-1
          %h2.hidden How does version control streamline collaboration?
          %h2.u-text-brand How does version control streamline collaboration?

          %p Version control coordinates all changes in a software project, effectively tracking changes to source files, designs, and all digital assets required for a project and related metadata. Projects without version control and collaboration can easily devolve into a tangled mess of different versions of project files, hindering the ability of any software development team to deliver value. With a strong version control solution, software teams can quickly assemble all critical project files and foster actionable communication to improve code quality. Stakeholders from across a DevOps team can collaborate to build innovative solutions - from product managers and designers to developers and operations professionals. 
          %h4.bold-links
            = link_to "Discover 15 best practices for large teams to innovate and collaborate using source code management→", "https://page.gitlab.com/resources-ebook-scm-for-enterprise.html"



      .row.u-margin-top-xl.u-margin-bottom-xl.js-in-page-nav-section#resources
        .col-md-10.col-md-offset-1
          %h2.hidden What's next
          %h2.u-text-brand Next steps in version control
          %p Ready to learn more about version control? Here are a few resources to help you get started on your journey.

          %div
            %ul.bold-links
              %li
                = link_to "Learn how GitLab streamlines software development →", "/solutions/version-control/"
              %li
                = link_to "Worldline improves code reviews’ potential by 120x →", "/customers/worldline/"
              %li
                = link_to "Watch how GitLab SCM and code review spark velocity →", "https://page.gitlab.com/resources-demo-scm.html"

